<?php
/**
 * Connected
 *
 * @license		GPL
 * @package		Connected
 * @link		https://gitlab.liris.cnrs.fr/mloiseau/mw_connected
 *
 **/
 $wgExtensionMessagesFiles['Connected'] = __DIR__ . '/Connected.i18n.magic.php';

 class ConnectedHooks {
	// Register any render callbacks with the parser
	public static function onParserFirstCallInit( Parser $parser ) {

		// Create a function hook associating the "example" magic word with renderExample()
		$parser->setFunctionHook( 'ifloggedin', [ self::class, 'ifConnectedRender' ] );
	}

	// Render the output of {{#example:}}.
	public static function ifConnectedRender( Parser $parser, $ifLoggedIn = '', $ifNot = '') {
		// The input parameters are wikitext with templates expanded.
		// The output should be wikitext too.
		global $wgUser;
		if($wgUser->isSafeToLoad()){
			if ( $wgUser->isLoggedIn() ) {
				$output = $ifLoggedIn;
			}
			else{
				$output = $ifNot;
			}

		return $output;
	}

	public static function wfConnectedAssignValue( Parser $parser, &$cache, &$magicWordId, &$ret ) {
		global $wgUser;
		$result = false;
		if($wgUser->isSafeToLoad()){
			if ( !$wgUser->isLoggedIn() ) {
				switch($magicWordId){
					case 'connected' :
						$ret = 0;
						$result = true;
						break;
					case 'u_name':
						$ret = $wgUser->getName();
						$result = true;
						break;
				}
			}
			else{
				switch($magicWordId){
					case 'connected' :
						$ret = 1;
						$result = true;
						break;
					case 'u_name':
						$ret = $wgUser->getName();
						$result = true;
						break;
				}
			}
		}
		return $result;
	}

	function connectedDeclareVarIds( &$customVariableIds ) {
		// $customVariableIds is where MediaWiki wants to store its list of custom
		// variable IDs. We oblige by adding ours:
		$customVariableIds[] = 'connected';
		$customVariableIds[] = 'u_name';
	}
}

$wgHooks['MagicWordwgVariableIDs'][] = 'connectedMyDeclareVarIds';
